diff -c ../zip19i/fileio.c ./fileio.c
*** ../zip19i/fileio.c	Tue Nov  3 21:07:54 1992
--- ./fileio.c	Fri Sep 10 05:02:28 1993
***************
*** 1,16 ****
  /*
  
!  Copyright (C) 1990-1992 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included
!  unmodified, that it is not sold for profit, and that this copyright notice
!  is retained.
  
  */
  
  /*
   *  fileio.c by Mark Adler.
   */
  
  #include "zip.h"
--- 1,18 ----
  /*
  
!  Copyright (C) 1990-1993 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included,
!  that it is not sold for profit, and that this copyright notice is retained.
  
  */
  
  /*
   *  fileio.c by Mark Adler.
+  *
+  *  This file has become a big mess over time, and will be split in the
+  *  next version, one file per operating system.
   */
  
  #include "zip.h"
***************
*** 20,25 ****
--- 22,28 ----
  #ifdef WIN32
  #  include <sys/utime.h>
  #  include <windows.h> /* for findfirst/findnext */
+    char *GetLongPathEA OF((char *name));
  #endif
  
  #ifdef MACOS
***************
*** 53,63 ****
  #    endif
  #  endif /* ?__TURBOC__ */
  #  define link rename
! #  ifdef OS2
  #    define MATCH shmatch
! #  else /* !OS2 */
  #    define MATCH dosmatch
! #  endif /* ?OS2 */
  #else /* !MSDOS */
     extern int errno;    /* error number from system functions */
  #  ifdef TOPS20
--- 56,66 ----
  #    endif
  #  endif /* ?__TURBOC__ */
  #  define link rename
! #  if defined(OS2) || defined(WIN32)
  #    define MATCH shmatch
! #  else
  #    define MATCH dosmatch
! #  endif
  #else /* !MSDOS */
     extern int errno;    /* error number from system functions */
  #  ifdef TOPS20
***************
*** 87,96 ****
  #  define RMDIR
  #endif /* UTS */
  
  
  /* Extra malloc() space in names for cutpath() */
  #if (defined(VMS) || defined(TOPS20))
! #  define PAD 3         /* may have to change .FOO] to ]FOO.DIR */
  #else
  #  define PAD 0
  #  define PATH_END '/'
--- 90,124 ----
  #  define RMDIR
  #endif /* UTS */
  
+ #ifdef AMIGA
+ #  define link rename
+ #  define utime FileDate
+ #  ifdef __SASC_60
+ #    include <dos.h>               /* SAS/C 6.x , pulled by wild() */
+ #    include <sys/dir.h>
+ #    define direct dirent
+ #    define disk_not_mounted 0  
+ #  else
+ #    define dirent direct
+ #  endif
+ #  ifdef MODERN
+ #    include <clib/exec_protos.h>
+ #    include <clib/dos_protos.h>
+ #  endif
+ #  ifdef AZTEC_C
+ #    include <pragmas/exec_lib.h>
+ #    include <pragmas/dos_lib.h>
+ #  endif
+ #endif 
+ 
+ #ifdef __human68k__
+ #  include <jctype.h>
+ #  define link rename
+ #endif
  
  /* Extra malloc() space in names for cutpath() */
  #if (defined(VMS) || defined(TOPS20))
! #  define PAD 5         /* may have to change .FOO] to ]FOO.DIR;1 */
  #else
  #  define PAD 0
  #  define PATH_END '/'
***************
*** 102,117 ****
  #  include <rms.h>
  #endif
  
! /* For directory access. (This is getting rather messy. Cleanup
!  * scheduled for version 17.9.)
!  */
  #ifndef UTIL
  
! #if defined(SYSV) || defined(__GO32__)   /* use readdir()  */
  #  include <dirent.h>
  #  define dstrm DIR
  #  define direct dirent
! #else /* !SYSV && !__GO32__ */
  
  #ifdef DIRENT                   /* use getdents() */
  #ifndef TOPS20
--- 130,149 ----
  #  include <rms.h>
  #endif
  
! /* For directory access. */
! 
  #ifndef UTIL
  
! #ifdef __human68k__
! #include <sys/dos.h>
! #endif
! 
! #if defined(SYSV) || defined(__GO32__) || defined(__386BSD__) || defined(__human68k__)
! /* use readdir() */
  #  include <dirent.h>
  #  define dstrm DIR
  #  define direct dirent
! #else /* !SYSV && !__GO32__ && !__386BSD__ && !__human68k__*/
  
  #ifdef DIRENT                   /* use getdents() */
  #ifndef TOPS20
***************
*** 139,153 ****
  #  define FALSE 0
  #  define O_RDONLY (0)
  #  define O_T20_WILD (1<<18)
! #  include <monsym.h>	/* Get amazing monsym() macro */
     extern int jsys(), fstat();
     extern char *getcwd();
     extern int _gtjfn(), _rljfn();
! #  define JSYS_CLASS	0070000000000
  #  define FLD(val,mask) (((unsigned)(val)*((mask)&(-(mask))))&(mask))
  #  define _DEFJS(name,class) (FLD(class, JSYS_CLASS) | (monsym(name)&0777777))
! #  define JFNS	_DEFJS("JFNS%", 1)
! #  define GNJFN	_DEFJS("GNJFN%", 0)
     static int wfopen(), wfnext(), strlower(), strupper();
     static char *wfname();
     typedef struct {
--- 171,185 ----
  #  define FALSE 0
  #  define O_RDONLY (0)
  #  define O_T20_WILD (1<<18)
! #  include <monsym.h>    /* Get amazing monsym() macro */
     extern int jsys(), fstat();
     extern char *getcwd();
     extern int _gtjfn(), _rljfn();
! #  define JSYS_CLASS    0070000000000
  #  define FLD(val,mask) (((unsigned)(val)*((mask)&(-(mask))))&(mask))
  #  define _DEFJS(name,class) (FLD(class, JSYS_CLASS) | (monsym(name)&0777777))
! #  define JFNS  _DEFJS("JFNS%", 1)
! #  define GNJFN _DEFJS("GNJFN%", 0)
     static int wfopen(), wfnext(), strlower(), strupper();
     static char *wfname();
     typedef struct {
***************
*** 171,199 ****
  #     ifdef OS2
  #      include "os2zip.h"
  #     else /* !OS2 */
  #      ifndef ATARI_ST
  #        include <dos.h>
  #      endif
  #      ifdef __TURBOC__
! #        define FATTR           FA_HIDDEN+FA_SYSTEM+FA_DIREC
! #        define FFIRST(n,d)     findfirst(n,(struct ffblk *)d,FATTR)
  #        define FNEXT(d)        findnext((struct ffblk *)d)
  #      else /* !__TURBOC__ */
! #        define FATTR           _A_HIDDEN+_A_SYSTEM+_A_SUBDIR
! #        define FFIRST(n,d)     _dos_findfirst(n,FATTR,(struct find_t *)d)
  #        define FNEXT(d)        _dos_findnext((struct find_t *)d)
  #      endif /* ?__TURBOC__ */
         typedef struct direct {
!          char d_reserved[30];
  #      ifndef WIN32
           char d_name[13];
! 	 int d_first;
  #      else
           char d_name[MAX_PATH];
! 	 int d_first;
           HANDLE d_hFindFile;
  #      endif /* WIN32 */
         } DIR;
  #     endif /* ?OS2 */
  #    else /* !MSDOS */
  #      ifdef VMS
--- 203,241 ----
  #     ifdef OS2
  #      include "os2zip.h"
  #     else /* !OS2 */
+ #      ifdef WIN32
+ #        include "ntzip.h"
+ #      endif
  #      ifndef ATARI_ST
  #        include <dos.h>
  #      endif
  #      ifdef __TURBOC__
! #        define FATTR (hidden_files ? FA_HIDDEN+FA_SYSTEM+FA_DIREC : FA_DIREC)
! #        define FFIRST(n,d,a)   findfirst(n,(struct ffblk *)d,a)
  #        define FNEXT(d)        findnext((struct ffblk *)d)
  #      else /* !__TURBOC__ */
! #        define FATTR (hidden_files ? _A_HIDDEN+_A_SYSTEM+_A_SUBDIR :_A_SUBDIR)
! #        define FA_LABEL _A_VOLID
! #        define FFIRST(n,d,a)   _dos_findfirst(n,a,(struct find_t *)d)
  #        define FNEXT(d)        _dos_findnext((struct find_t *)d)
  #      endif /* ?__TURBOC__ */
         typedef struct direct {
!          char   reserved [21];
!          char   ff_attrib;
!          short  ff_ftime;
!          short  ff_fdate;
!          long   size;
  #      ifndef WIN32
           char d_name[13];
!          int d_first;
  #      else
           char d_name[MAX_PATH];
!          int d_first;
           HANDLE d_hFindFile;
  #      endif /* WIN32 */
         } DIR;
+        typedef DIR ff_dir;
+ #      define ff_name d_name /* ff_name is used by DJGPP */
  #     endif /* ?OS2 */
  #    else /* !MSDOS */
  #      ifdef VMS
***************
*** 212,241 ****
               char *d_name;
            } DIR;
  #        endif
! #        ifdef M_XENIX
  #          include <sys/ndir.h>
  #        else /* !M_XENIX */
! #          include <sys/dir.h>
  #        endif /* ?M_XENIX */
! #        ifdef NODIR                    /* for AT&T 3B1 */
  #          define dirent direct
             typedef FILE DIR;
- #          define dstrm DIR
  #        endif /* NODIR */
  #      endif /* ?VMS */
  #    endif /* ?MSDOS */
  #  endif /* ?NDIR */
  #  define dstrm DIR
! #  ifndef NODIR
!      DIR *opendir OF((char *));
! #  endif /* !NODIR */
! #  ifndef CONVEX
!      struct direct *readdir OF((DIR *));
! #  endif /* !CONVEX */
  #endif /* ?DIRENT */
  #endif /* ?SYSV */
  #endif /* !UTIL */
  
  
  /* Library functions not in (most) header files */
  
--- 254,293 ----
               char *d_name;
            } DIR;
  #        endif
! #        if defined(M_XENIX) || defined(SYSNDIR)
  #          include <sys/ndir.h>
  #        else /* !M_XENIX */
! #          ifndef AZTEC_C
! #            include <sys/dir.h>
! #          endif
  #        endif /* ?M_XENIX */
! #        ifdef NODIR                    /* for AT&T 3B1 + Amiga non SAS */
  #          define dirent direct
             typedef FILE DIR;
  #        endif /* NODIR */
  #      endif /* ?VMS */
  #    endif /* ?MSDOS */
  #  endif /* ?NDIR */
  #  define dstrm DIR
! #  if defined(MSDOS) && !defined(OS2)
! #    ifndef __GO32__
!        DIR *opendir OF((const char *));
!        struct direct *readdir OF((DIR *));
! #    endif
! #    ifndef WIN32
!        char *getVolumeLabel OF((int drive, ulg *vtime, ulg *vmode));
! #    endif
! #  endif
  #endif /* ?DIRENT */
  #endif /* ?SYSV */
  #endif /* !UTIL */
  
+ #ifdef __GO32__
+    typedef struct ffblk ff_dir;
+ #  define FFIRST(n,d,a)   findfirst(n,(struct ffblk *)d,a)
+ #endif
+ 
+ #define MSDOS_DIR_ATTR 0x10
  
  /* Library functions not in (most) header files */
  
***************
*** 248,283 ****
  #endif
  char *mktemp OF((char *));
  
! #ifndef __GO32__
!   int link OF((char *, char *));
!   int unlink OF((char *));
! # if defined(MSDOS)
!    int chmod OF((char *, int));
!    /* For many targets, chmod is already defined by sys/stat.h, and second
!     * parameter is an unsigned long.
!     */
! # endif
! #else
  #  include <dos.h>
  #endif
  
  
  #ifndef UTIL    /* the companion #endif is a bit of ways down ... */
  
! #ifndef __TURBOC__
     int utime OF((char *, time_t *));
! #endif /* !__TURBOC__ */
  #ifndef MSDOS
!    int open OF((char *, int, ...));
!    int close OF((int));
  #  ifndef RMDIR
!      int rmdir OF((char *));
  #  endif /* !RMDIR */
  #endif /* !MSDOS */
  
  
  /* Local globals (kinda like "military intelligence" or "broadcast quality") */
! local int exflag = 0;           /* Exclude flag */
  
  #ifdef VMS
    typedef int statime;
--- 300,339 ----
  #endif
  char *mktemp OF((char *));
  
! #ifdef __GO32__
  #  include <dos.h>
+ #else
+   /* int link OF((const char *, const char *)); */
+   /* int unlink OF((const char *)); */
+   /* int chmod OF((const char *, int)); */
+   /* For many targets, chmod is already defined by sys/stat.h, and second
+    * parameter is an unsigned long.
+    */
  #endif
  
  
  #ifndef UTIL    /* the companion #endif is a bit of ways down ... */
  
! #if !defined(__TURBOC__) && !defined(WIN32) && !defined(sgi)
     int utime OF((char *, time_t *));
! #endif
  #ifndef MSDOS
!    /* int open OF((char *, int, ...)); */
!    /* int close OF((int)); */
  #  ifndef RMDIR
!      /* int rmdir OF((const char *)); */
  #  endif /* !RMDIR */
  #endif /* !MSDOS */
  
  
  /* Local globals (kinda like "military intelligence" or "broadcast quality") */
! local struct stat zipstatb;
! local int zipstate = -1;
! /* -1 unknown, 0 old zip file exists, 1 new zip file */
! 
! local char *label = NULL;
! local ulg label_time = 0;
! local ulg label_mode = 0;
  
  #ifdef VMS
    typedef int statime;
***************
*** 295,309 ****
       local void closed(dstrm *);
  #  endif /* DIRENT */
     local char *readd(dstrm *);
!    local int fqcmp(voidp *, voidp *);
!    local int fqcmpz(voidp *, voidp *);
     local char *last(char *);
     local char *msname(char *);
  #  ifdef VMS
       local char *strlower(char *);
       local char *strupper(char *);
  #  endif /* VMS */
-    local char *ex2in(char *, int, int *);
     local int newname(char *, int);
     local void inctime(struct tm *);
     local ulg unix2dostime(statime *);
--- 351,364 ----
       local void closed(dstrm *);
  #  endif /* DIRENT */
     local char *readd(dstrm *);
!    local int fqcmp(const voidp *, const voidp *);
!    local int fqcmpz(const voidp *, const voidp *);
     local char *last(char *);
     local char *msname(char *);
  #  ifdef VMS
       local char *strlower(char *);
       local char *strupper(char *);
  #  endif /* VMS */
     local int newname(char *, int);
     local void inctime(struct tm *);
     local ulg unix2dostime(statime *);
***************
*** 316,366 ****
  
  #if defined(MSDOS) && !defined(OS2) && !defined(__GO32__)
  dstrm *opendir(n)
! char *n;                /* directory to open */
  /* Start searching for files in the MSDOS directory n */
  {
    dstrm *d;             /* malloc'd return value */
    char *p;              /* malloc'd temporary string */
  
    if ((d = (dstrm *)malloc(sizeof(dstrm))) == NULL ||
!       (p = malloc(strlen(n) + 5)) == NULL)
      return NULL;
    strcat(strcpy(p, n), "/");
    strcat(p, "*.*"); /* don't use strcat in one step, TOPS20 is confused */
  
  #ifdef WIN32
    {
!   WIN32_FIND_DATA fd;
!   DWORD dwAttr;
!   BOOL bAttr;
  
!   if ((HANDLE)0xFFFFFFFF == (d->d_hFindFile = FindFirstFile(p, &fd)))
      {
!     free((voidp *)p);
!     return NULL;
      }
-   else
      strcpy(d->d_name, fd.cFileName);
!   if (-1 != (dwAttr = GetFileAttributes(fd.cFileName)))
      {
!     bAttr = FALSE;
!     if (FILE_ATTRIBUTE_SYSTEM == (dwAttr & FILE_ATTRIBUTE_SYSTEM))
! 	bAttr = TRUE;
!     if (FILE_ATTRIBUTE_HIDDEN == (dwAttr & FILE_ATTRIBUTE_HIDDEN))
! 	bAttr = TRUE;
!     if (FILE_ATTRIBUTE_DIRECTORY == (dwAttr & FILE_ATTRIBUTE_DIRECTORY))
! 	bAttr = TRUE;
!     if (!bAttr)
! 	{
! 	free ((voidp *)p);
! 	free ((void *) d);
! 	return NULL;
! 	}
      }
- 
    }
  #else
!   if (FFIRST(p, d))
    {
      free((voidp *)p);
      return NULL;
--- 371,416 ----
  
  #if defined(MSDOS) && !defined(OS2) && !defined(__GO32__)
  dstrm *opendir(n)
! const char *n;                /* directory to open */
  /* Start searching for files in the MSDOS directory n */
  {
    dstrm *d;             /* malloc'd return value */
    char *p;              /* malloc'd temporary string */
  
    if ((d = (dstrm *)malloc(sizeof(dstrm))) == NULL ||
!       (p = malloc(strlen(n) + 5)) == NULL) {
!     if (d != NULL) free((void *) d);
      return NULL;
+   }
    strcat(strcpy(p, n), "/");
    strcat(p, "*.*"); /* don't use strcat in one step, TOPS20 is confused */
  
  #ifdef WIN32
    {
!     WIN32_FIND_DATA fd;
!     DWORD dwAttr;
  
!     if ( INVALID_HANDLE_VALUE == (d->d_hFindFile = FindFirstFile(p, &fd)))
      {
!       free((voidp *)p);
!       return NULL;
      }
      strcpy(d->d_name, fd.cFileName);
! 
!     if (-1 != (dwAttr = GetFileAttributes(fd.cFileName)))
      {
!       if (!hidden_files &&
!          (FILE_ATTRIBUTE_SYSTEM == (dwAttr & FILE_ATTRIBUTE_SYSTEM) ||
!           FILE_ATTRIBUTE_HIDDEN == (dwAttr & FILE_ATTRIBUTE_HIDDEN)))
!       {
!           free ((voidp *)p);
!           d->d_first = 0;
!           return d;
!       }
      }
    }
  #else
!   if (FFIRST(p, d, FATTR))
    {
      free((voidp *)p);
      return NULL;
***************
*** 379,399 ****
      d->d_first = 0;
    else
  #ifdef WIN32
!     {
      WIN32_FIND_DATA fd;
  
      if (!FindNextFile(d->d_hFindFile, &fd))
! 	return NULL;
!     else
! 	strcpy(d->d_name, fd.cFileName);
      }
  #else /* !WIN32 */
      if (FNEXT(d))
        return NULL;
  #endif
    return (struct direct *)d;
  }
  #  define closedir free
  
  #endif /* MSDOS && !OS2 && !__GO32__ */
  
--- 429,468 ----
      d->d_first = 0;
    else
  #ifdef WIN32
!   {
      WIN32_FIND_DATA fd;
+     DWORD dwAttr;
  
      if (!FindNextFile(d->d_hFindFile, &fd))
!         return NULL;
! 
!     strcpy(d->d_name, fd.cFileName);
! 
!     if (!hidden_files &&
!        (-1 != (dwAttr = GetFileAttributes(fd.cFileName))) &&
!        (FILE_ATTRIBUTE_SYSTEM == (dwAttr & FILE_ATTRIBUTE_SYSTEM) ||
!         FILE_ATTRIBUTE_HIDDEN == (dwAttr & FILE_ATTRIBUTE_HIDDEN)))
!     {
!         return (readdir(d));
      }
+   }
  #else /* !WIN32 */
      if (FNEXT(d))
        return NULL;
  #endif
    return (struct direct *)d;
+ 
+ }
+ #ifdef WIN32
+ void closedir(d)
+ dstrm *d;
+ {
+         FindClose(d->d_hFindFile);
+         free(d);
  }
+ #else
  #  define closedir free
+ #endif
  
  #endif /* MSDOS && !OS2 && !__GO32__ */
  
***************
*** 409,414 ****
--- 478,486 ----
      behavior of MS-DOS (MSC and Turbo C) findfirst and findnext functions.
  
    ---------------------------------------------------------------------------*/
+ 
+ static char wild_version_part[10]="\0";
+ 
  local void vms_wild(p, d)
  char *p;
  dstrm *d;
***************
*** 476,481 ****
--- 548,554 ----
      *c = '.';           /* "]" --> "." */
    }
    strcat(p, "*.*");
+   strcat(p, wild_version_part);
    vms_wild(p, d);       /* set up wildcard */
    free((voidp *)p);
    return d;
***************
*** 537,566 ****
     NULL if error. */
  {
      dstrm *d;             /* pointer to malloc'ed directory stream */
!     char    *c;				/* scans TOPS20 path */
!     int	    m;				/* length of name */
!     char    *p;				/* temp string */
  
      if (((d = (dstrm *)malloc(sizeof(dstrm))) == NULL) ||
! 	((p = (char *)malloc((m = strlen(n)) + 4)) == NULL)) {
! 	    return NULL;
      }
  
  /* Directory may be in form "<DIR.SUB1.SUB2>" or "<DIR.SUB1>SUB2.DIRECTORY".
  ** If latter, convert to former. */
  
      if ((m > 0)  &&  (*(c = strcpy(p,n) + m-1) != '>')) {
! 	c -= 10;
! 	*c-- = '\0';        /* terminate at "DIRECTORY.1" */
! 	*c = '>';           /* "." --> ">" */
! 	while ((c > p)  &&  (*--c != '>'));
! 	*c = '.';           /* ">" --> "." */
      }
      strcat(p, "*.*");
      if ((d->wfjfn = wfopen(p)) == 0) {
! 	free((voidp *)d);
! 	free((voidp *)p);
! 	return NULL;
      }
      free((voidp *)p);
      d->more = TRUE;
--- 610,639 ----
     NULL if error. */
  {
      dstrm *d;             /* pointer to malloc'ed directory stream */
!     char    *c;                         /* scans TOPS20 path */
!     int     m;                          /* length of name */
!     char    *p;                         /* temp string */
  
      if (((d = (dstrm *)malloc(sizeof(dstrm))) == NULL) ||
!         ((p = (char *)malloc((m = strlen(n)) + 4)) == NULL)) {
!             return NULL;
      }
  
  /* Directory may be in form "<DIR.SUB1.SUB2>" or "<DIR.SUB1>SUB2.DIRECTORY".
  ** If latter, convert to former. */
  
      if ((m > 0)  &&  (*(c = strcpy(p,n) + m-1) != '>')) {
!         c -= 10;
!         *c-- = '\0';        /* terminate at "DIRECTORY.1" */
!         *c = '>';           /* "." --> ">" */
!         while ((c > p)  &&  (*--c != '>'));
!         *c = '.';           /* ">" --> "." */
      }
      strcat(p, "*.*");
      if ((d->wfjfn = wfopen(p)) == 0) {
!         free((voidp *)d);
!         free((voidp *)p);
!         return NULL;
      }
      free((voidp *)p);
      d->more = TRUE;
***************
*** 618,624 ****
    d->p += ((struct direct *)(d->p))->d_reclen;  /* advance */
    return e->d_name;                             /* return name */
  # else /* !DIRENT */
!   return (e = readdir(d)) == NULL ? (char *)NULL : e->d_name;
  # endif /* ?DIRENT */
  #endif /* ?TOPS20 */
  }
--- 691,698 ----
    d->p += ((struct direct *)(d->p))->d_reclen;  /* advance */
    return e->d_name;                             /* return name */
  # else /* !DIRENT */
!   e = readdir(d);
!   return e == NULL ? (char *)NULL : e->d_name;
  # endif /* ?DIRENT */
  #endif /* ?TOPS20 */
  }
***************
*** 642,648 ****
  /* Wildcard filename routines */
  
  /* WFOPEN - open wild card filename
! **	Returns wild JFN for filespec, 0 if failure.
  */
  static int
  wfopen(name)
--- 716,722 ----
  /* Wildcard filename routines */
  
  /* WFOPEN - open wild card filename
! **      Returns wild JFN for filespec, 0 if failure.
  */
  static int
  wfopen(name)
***************
*** 652,658 ****
  }
  
  /* WFNAME - Return filename for wild JFN
! **	Returns pointer to dynamically allocated filename string
  */
  static char *
  wfname(jfn)
--- 726,732 ----
  }
  
  /* WFNAME - Return filename for wild JFN
! **      Returns pointer to dynamically allocated filename string
  */
  static char *
  wfname(jfn)
***************
*** 662,680 ****
      int ablock[5];
  
      ablock[1] = (int) (fname - 1);
!     ablock[2] = jfn & 0777777;	/* jfn, no flags */
!     ablock[3] = 0111110000001;	/* DEV+DIR+NAME+TYPE+GEN, punctuate */
      if (!jsys(JFNS, ablock))
! 	return NULL;		/* something bad happened */
      if ((fp = (char *)malloc(strlen(fname) + 1)) == NULL) {
! 	return NULL;
      }
!     strcpy(fp, fname);		/* copy the file name here */
      return fp;
  }
  
  /* WFNEXT - Make wild JFN point to next real file
! **	Returns success or failure (not JFN)
  */
  static int
  wfnext(jfn)
--- 736,754 ----
      int ablock[5];
  
      ablock[1] = (int) (fname - 1);
!     ablock[2] = jfn & 0777777;  /* jfn, no flags */
!     ablock[3] = 0111110000001;  /* DEV+DIR+NAME+TYPE+GEN, punctuate */
      if (!jsys(JFNS, ablock))
!         return NULL;            /* something bad happened */
      if ((fp = (char *)malloc(strlen(fname) + 1)) == NULL) {
!         return NULL;
      }
!     strcpy(fp, fname);          /* copy the file name here */
      return fp;
  }
  
  /* WFNEXT - Make wild JFN point to next real file
! **      Returns success or failure (not JFN)
  */
  static int
  wfnext(jfn)
***************
*** 682,700 ****
  {
      int ablock[5];
  
!     ablock[1] = jfn;		/* save jfn and flags */
      return jsys(GNJFN, ablock);
  }
  #endif /* TOPS20 */
    
  
! #if defined(MSDOS) && !defined(__GO32__)
  
  int wild(w)
  char *w;                /* path/pattern to match */
  /* If not in exclude mode, expand the pattern based on the contents of the
     file system.  Return an error code in the ZE_ class. */
  {
    char *a;              /* alloc'ed space for name */
    dstrm *d;             /* stream for reading directory */
    char *e;              /* name found in directory */
--- 756,837 ----
  {
      int ablock[5];
  
!     ablock[1] = jfn;            /* save jfn and flags */
      return jsys(GNJFN, ablock);
  }
  #endif /* TOPS20 */
    
  
! #ifdef __human68k__
! int wild(w)
! char *w;
! {
!   struct _filbuf inf;
!   int r;
!   extern int _hupair;
!   char name[FNMAX];
!   char *p;
! 
!   if (_hupair)
!     return procname(w);         /* if argv's passed hupair, don't glob */
!   strcpy(name, w);
!   _toslash(name);
!   if ((p = strrchr(name, '/')) == NULL && (p = strrchr(name, ':')) == NULL)
!     p = name;
!   else
!     p++;
!   if (_dos_files (&inf, w, 0xff) < 0)
!     return ZE_MISS;
!   do {
!     strcpy(p, inf.name);
!     r = procname(name);
!     if (r != ZE_OK)
!       return r;
!   } while (_dos_nfiles(&inf) >= 0);
! 
!   return ZE_OK;
! }
! #endif
  
+ #if defined(MSDOS) && !defined(OS2) && !defined(WIN32)
+ 
+ char *getVolumeLabel(drive, vtime, vmode)
+   int drive;  /* drive name: 'A' .. 'Z' or '\0' for current drive */
+   ulg *vtime; /* volume label creation time (DOS format) */
+   ulg *vmode; /* volume label file mode */
+ 
+ /* If a volume label exists for the given drive, return its name and
+    set its time and mode. The returned name must be static data. */
+ {
+   static char vol[14];
+   ff_dir d;
+ 
+   if (drive) {
+     vol[0] = (char)drive;
+     strcpy(vol+1, ":/");
+   } else {
+     strcpy(vol, "/");
+   }
+   strcat(vol, "*.*");
+   if (FFIRST(vol, &d, FA_LABEL) == 0) {
+     strncpy(vol, d.ff_name, sizeof(vol)-1);
+     *vtime = ((ulg)d.ff_fdate << 16) | ((ulg)d.ff_ftime & 0xffff);
+     *vmode = (ulg)d.ff_attrib;
+     return vol;
+   }
+   return NULL;
+ }
+ 
+ #endif /*  MSDOS && !OS2 && !WIN32 */
+ 
+ #if defined(MSDOS) || defined(OS2)
+ 
  int wild(w)
  char *w;                /* path/pattern to match */
  /* If not in exclude mode, expand the pattern based on the contents of the
     file system.  Return an error code in the ZE_ class. */
  {
+ # ifndef __GO32__
    char *a;              /* alloc'ed space for name */
    dstrm *d;             /* stream for reading directory */
    char *e;              /* name found in directory */
***************
*** 704,728 ****
    char *q;              /* name */
    int r;                /* temporary variable */
    char v[5];            /* space for device current directory */
  
    /* Allocate and copy pattern */
    if ((p = a = malloc(strlen(w) + 1)) == NULL)
      return ZE_MEM;
    strcpy(p, w);
  
!   /* Normalize pattern to upper case, path delimiter as '/'. */
    for (q = p; *q; q++)                  /* use / consistently */
      if (*q == '\\')
        *q = '/';
  
-   /* If excluding, don't bother with file system */
-   if (exflag)
-   {
-     r = procname(p);
-     free((voidp *)a);
-     return r;
-   }
- 
    /* Only name can have special matching characters */
    if ((q = isshexp(p)) != NULL &&
        (strrchr(q, '/') != NULL || strrchr(q, ':') != NULL))
--- 841,873 ----
    char *q;              /* name */
    int r;                /* temporary variable */
    char v[5];            /* space for device current directory */
+ # endif /* __GO32__ */
  
+ # ifndef WIN32
+   if (volume_label == 1) {
+     volume_label = 2;
+     label = getVolumeLabel(w[1] == ':' ? to_up(w[0]) : '\0',
+                            &label_time, &label_mode);
+     if (label != NULL) {
+        newname(label, 0);
+     }
+     if (w[1] == ':' && w[2] == '\0') return ZE_OK;
+     /* "zip -$ foo a:" can be used to force drive name */
+   }
+ # endif
+ # ifdef __GO32__
+   return procname(w); /* expansion already done by DJGPP */
+ # else
    /* Allocate and copy pattern */
    if ((p = a = malloc(strlen(w) + 1)) == NULL)
      return ZE_MEM;
    strcpy(p, w);
  
!   /* Normalize path delimiter as '/'. */
    for (q = p; *q; q++)                  /* use / consistently */
      if (*q == '\\')
        *q = '/';
  
    /* Only name can have special matching characters */
    if ((q = isshexp(p)) != NULL &&
        (strrchr(q, '/') != NULL || strrchr(q, ':') != NULL))
***************
*** 754,759 ****
--- 899,913 ----
      q = p;
      p = strcpy(v, ".");
    }
+   /* I can't understand Mark's code so I am adding a hack here to get
+    * "zip -r foo ." to work. Allow the dubious "zip -r foo .." but
+    * reject "zip -rm foo ..".
+    */
+   if (recurse && (strcmp(q, ".") == 0 ||  strcmp(q, "..") == 0)) {
+      if (dispose && strcmp(q, "..") == 0)
+         err(ZE_PARMS, "cannot remove parent directory");
+      return procname(p);
+   }
  
    /* Search that level for matching names */
    if ((d = opend(p)) == NULL)
***************
*** 765,781 ****
        (strcmp(p + r - 2, ":.") == 0 || strcmp(p + r - 2, "/.") == 0))
      *(p + r - 1) = 0;
    f = 0;
!   while ((e = readd(d)) != NULL)
      if (strcmp(e, ".") && strcmp(e, "..") && MATCH(q, e))
      {
        f = 1;
!       if (strcmp(p, ".") == 0)                  /* path is . */
!         procname(e);                            /* name is name */
!       else
        {
          if ((n = malloc(strlen(p) + strlen(e) + 2)) == NULL)
          {
            free((voidp *)a);
            return ZE_MEM;
          }
          n = strcpy(n, p);
--- 919,940 ----
        (strcmp(p + r - 2, ":.") == 0 || strcmp(p + r - 2, "/.") == 0))
      *(p + r - 1) = 0;
    f = 0;
!   while ((e = readd(d)) != NULL) {
      if (strcmp(e, ".") && strcmp(e, "..") && MATCH(q, e))
      {
        f = 1;
!       if (strcmp(p, ".") == 0) {                /* path is . */
!         r = procname(e);                        /* name is name */
!         if (r) {
!            f = 0;
!            break;
!         }
!       } else
        {
          if ((n = malloc(strlen(p) + strlen(e) + 2)) == NULL)
          {
            free((voidp *)a);
+           closed(d);
            return ZE_MEM;
          }
          n = strcpy(n, p);
***************
*** 783,805 ****
            strcat(n, "/");
          r = procname(strcat(n, e));             /* name is path/name */
          free((voidp *)n);
!         if (r)
!         {
!           free((voidp *)a);
!           return r;
          }
        }
      }
    closed(d);
  
    /* Done */
    free((voidp *)a);
    return f ? ZE_OK : ZE_MISS;
  }
! #endif /* MSDOS && !__GO32__ */
  
! #if defined(MSDOS) && !defined(OS2)
! #  if (defined(__TURBOC__) || defined(__GO32__)) && !defined(__BORLANDC__)
  #   define GetFileMode(name) bdosptr(0x43, (name), 0)
  #  else
      int GetFileMode(char *name)
--- 942,965 ----
            strcat(n, "/");
          r = procname(strcat(n, e));             /* name is path/name */
          free((voidp *)n);
!         if (r) {
!           f = 0;
!           break;
          }
        }
      }
+   }
    closed(d);
  
    /* Done */
    free((voidp *)a);
    return f ? ZE_OK : ZE_MISS;
+ # endif /* __GO32__ */
  }
! #endif /* MSDOS || OS2 */
  
! #if defined(MSDOS) && !defined(OS2) && !defined(WIN32)
! #  if defined(__TURBOC__) || defined(__GO32__) || defined(__BORLANDC__)
  #   define GetFileMode(name) bdosptr(0x43, (name), 0)
  #  else
      int GetFileMode(char *name)
